﻿if Fence:HasModule('BidWatch') then return end

local L = AceLibrary("AceLocale-2.2"):new("Fence_BidWatch")
local l = AceLibrary("AceLocale-2.2"):new("Fence")
local abc = AceLibrary("Abacus-2.0")

local mod = Fence:NewModule("BidWatch")
Fence:RegisterDefaults('BidWatch', 'profile', {
	MaxBid = 100000
})

mod.db = Fence:AcquireDBNamespace("BidWatch")

function mod:OnInitialize()
	Fence.options.args.bidwatch = {
		type = 'group',
		name = L["Bid Watch"], aliases='bw',
		desc = L["Set a price limit for bids and warns you about it when the limit has been reached."],
		args = {
			toggle = {
				type = 'toggle',
				name = L["Bid Watch"],
				desc = string.format(l["Toggles %s function."], L["Bid Watch"]),
				get = function() return Fence:IsModuleActive("BidWatch") end,
				set = function(v) Fence:ToggleModuleActive("BidWatch", v) end
			},
			bidGUI = {
				cmdHidden = true,
				name = L["Bid"], 
				desc = L["Set upper bid limit in copper."],
				type = "range",
				get = function() return self.db.profile.MaxBid end,
				set = function(v)	
					self.db.profile.MaxBid = v 
					self:CreatePopup()
				end,
				min = 1000,
				max = 990000,
				step = 1000
			},
			bid = {
			guiHidden = true,
				name = L["Bid"], 
				desc = L["Set upper bid limit in copper."],
				type = "range",
				get = function() return abc:FormatMoneyFull(self.db.profile.MaxBid, true) end,
				set = function(v)	
					self.db.profile.MaxBid = v 
					self:CreatePopup()
				end,
				min = 1000,
				max = 990000,
			}
		}
	}
	self:CreatePopup()
end

function mod:OnEnable()
	self:RegisterEvent("AH_LOADED")
end

function mod:OnDisable()
	if self:IsHooked("PlaceAuctionBid") then self:Unhook("PlaceAuctionBid") end
end

function mod:AH_LOADED()
	self:Hook("PlaceAuctionBid", true)
	self:UnregisterEvent("AH_LOADED")
end

function mod:CreatePopup()
	StaticPopupDialogs["BID_BIND"] = {
		text = TEXT(L["WARNING!!!\n\nBid is greater than:\n"]..abc:FormatMoneyFull(self.db.profile.MaxBid, true)..L["\n\nAre you sure you wish to bid?"]),
		button1 = TEXT(OKAY),
		button2 = TEXT(CANCEL),
		OnAccept = function()
			self.hooks["PlaceAuctionBid"](self.itemtype ,self.itemindex ,self.bidamount)
		end,
		showAlert = 1,
		timeout = 0,
		exclusive = 1,
		whileDead = 1,
		interruptCinematic = 1
	}	
end

function mod:PlaceAuctionBid(itemtype,itemindex,bidamount)
	self.itemtype = itemtype
	self.itemindex = itemindex
	self.bidamount = bidamount
	
	if bidamount >= self.db.profile.MaxBid then
		local dialog = StaticPopup_Show("BID_BIND")
		if dialog then 
			self:Print(L["Bid for %s detected."], abc:FormatMoneyFull(bidamount,true)) 
		else 
			self.hooks["PlaceAuctionBid"](itemtype, itemindex ,bidamount)			
		end
	else
		self.hooks["PlaceAuctionBid"](itemtype, itemindex ,bidamount)
	end
end
